
Public Class frmCompression

    Private Sub btnCompress_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCompress.Click

        Dim byteSource() As Byte
        Dim byteCompressed() As Byte
        Dim oCCompression As New CComp

        ' Validate paths
        If IO.File.Exists(txtFilePath.Text) = False Then
            MsgBox("Please specify the valid file path to compress", MsgBoxStyle.OkOnly)
            txtFilePath.Focus()
            Exit Sub
        Else
            If IO.Directory.Exists(txtDestainationFolder.Text) = False Then
                MsgBox("Please specify the valid path of destination folder", MsgBoxStyle.OkOnly)
                txtDestainationFolder.Focus()
                Exit Sub
            End If
        End If


        Try
            Dim sFileName As String = txtFilePath.Text.Substring(txtFilePath.Text.LastIndexOf("\") + 1)

            byteSource = System.IO.File.ReadAllBytes(txtFilePath.Text)
            byteCompressed = oCCompression.CompressByte(byteSource)

            System.IO.File.WriteAllBytes(txtDestainationFolder.Text & "\" & sFileName & ".zip", byteCompressed)

            MsgBox("File compressed successfully and placed in destination folder", MsgBoxStyle.OkOnly, "Compression")

        Catch ex As Exception
            MsgBox("Compression failed. Reason: " & ex.ToString())
        End Try



    End Sub



    Private Sub btnDecompress_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDecompress.Click

        Dim oCDecompression As New CDecomp
        Dim byteDecompressed() As Byte

        ' Validate paths
        If IO.File.Exists(txtFilePath.Text) = False Then
            MsgBox("Please specify the valid file path to decompress", MsgBoxStyle.OkOnly)
            txtFilePath.Focus()
            Exit Sub
        Else
            If IO.Directory.Exists(txtDestainationFolder.Text) = False Then
                MsgBox("Please specify the valid path of destination folder", MsgBoxStyle.OkOnly)
                txtDestainationFolder.Focus()
                Exit Sub
            End If
        End If


        Try
            Dim sFileName As String = txtFilePath.Text.Substring(txtFilePath.Text.LastIndexOf("\") + 1)
            sFileName = sFileName.Remove(sFileName.LastIndexOf("."))

            byteDecompressed = oCDecompression.DecompressByte(System.IO.File.ReadAllBytes(txtFilePath.Text))

            System.IO.File.WriteAllBytes(txtDestainationFolder.Text & "\" & sFileName, byteDecompressed)
            MsgBox("File decompressed successfully and placed in destination folder", MsgBoxStyle.OkOnly, "Decompression")

        Catch ex As Exception
            MsgBox("Decompression failed. Reason: File used to decompress may not have gzip compression format")
        End Try


    End Sub

    Private Sub btnBrowseFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnBrowseFile.Click
        OpenFileDialog1.ShowDialog()
        txtFilePath.Text = OpenFileDialog1.FileName
    End Sub

    Private Sub btnBrowseFolder_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnBrowseFolder.Click
        FolderBrowserDialog1.ShowDialog()
        txtDestainationFolder.Text = FolderBrowserDialog1.SelectedPath
    End Sub


End Class
